#include <stdlib.h>
#include <stdio.h>
//#include <conio.h>
#include <string.h>
#include <ctype.h>

#include "neural.h"  // Defines all structs, #defines, and typedefs
#include "protos.h"  // Contains function prototypes for all of TSL's functions
// #define  MAX_ORGANISMS  100 // (I don't think this is needed. -MWS 2012)

int main (int argc, char *argv[])
{
  printf("________________________________________"
         "_______________________________________\n\n");
  Org *u, *v, **(*pop);
  char *configfile;
  long gen;
  int i, j, t;
  configfile = (char *) 0;

  for (i = 1; i < argc; i++)
    if (argv[i][0] != '-')
      configfile = argv[1];

  if (!configfile)
  {
    printf("usage: neural [options] inputfile\n");
    return 1;
  }
  if (!ReadConfiguration(configfile) |
      !ReadArgConfiguration(argc, argv))
    return 1;

  DisplayConfiguration();
  RandStart(c.seed);
  pop = (Org ***) CreateArray2(c.ndemes, c.npop, sizeof(Org *));
  for (i = 0; i < c.ndemes; i++)
  for (j = 0; j < c.npop;   j++)
  {
    Org *o = OrgCreate(c.ploidy);
    OrgInit(o);

    if (c.initcoords != NULL)
      OrgFromCoords(o, c.initcoords);
    else if (c.initzero)
      OrgZero(o);
    else
      OrgRand(o);

    OrgEval(o);

    pop[i][j] = o;                         // ** I think I want OrgInsert here.
  }
  FILE *f;
  char *fn = malloc(255*sizeof(char));
  sprintf(fn, "trace-%i.csv", (int)c.seed);
  if ((f = fopen(fn, "w")) == NULL) 
    printf("Error, could not open trace output file.\n"), exit(3);
  // if ((ff = fopen("trace-function.csv", "w")) == NULL)
  //    printf("error, could not open trace function output file.\n"), exit(3);
  #define  KEY_NULL   0
  #define  KEY_ESC    27
  #define  KEY_SPACE  32

  for (gen = 0; (!c.ngen || (gen < c.ngen)); gen++)
  {
//    if (kbhit())                           // Check the keyboard and read a
    if (0)                                 // Check the keyboard and read a
    {                                      // character if one is availble
      int key = getch();                   // (MS-DOS) specific).

      if (key == KEY_NULL)                 // If the special null code is read,
      {                                    // throw away the next character
        getch();                           // without translation.  (MS-DOS)
      }
      else if (key == KEY_ESC)             // If the Escape key is pressed, halt.
      {
        break;
      }
      else if (key == KEY_SPACE)           // If the space bar is pressed,
      {                                    // display the current weight and
        MatDisplay(pop[0][0]->ploid[0].M, "M"); //  threshold matrices.
        VecDisplay(pop[0][0]->ploid[0].B, "B", VDISPLAY);
//                                   ^ Temporary hack
      }
    }
    for (i = 0; i < c.ndemes; i++)
    {
      u = pop[i][RAND_INT_RANGE(0, c.npop - 1)];
      v = OrgClone(u);
      if (c.sigma != 0)
        PopEvalNoise(pop[i]);
      OrgMutate(v);
      OrgEval(v);
      if (OrgInsert(pop[i], c.npop, v) == 0)
      {
        if (c.errorweight)
          printf("Gen:%9ld      "
                 "e-dist:%10.6f     w-dist:%10.6f     dist:%10.6f\n",
                 gen, (double)v->edist, (double)v->wdist, (double)v->dist);
        else
          printf("Generation: %9ld            "
                 "e-dist: %13.6f\n",
                 gen, (double)v->edist);
        OrgTest(v);
        fprintf(f, "%i\t%.6f\t%.6f\t%.6f", 
                 (int)gen, (double)v->dist, (double)v->edist, (double)v->wdist);
        for (j=0; j<v->ploid[0].M->n; j++)
          if (v->ploid[0].M->m[j].mut)
              fprintf(f, "\t%.6f", (double)v->ploid[0].M->m[j].r);
        for (j=0; j<v->ploid[0].B->n; j++) 
          if (v->ploid[0].B->m[j].mut)
            fprintf(f, "\t%.6f", (double)v->ploid[0].B->m[j].r);
        fprintf(f, "\n");
        // int t;
        // for (t=0; t<c.ntest; t++)
        //   for (j=0; j<c.no; j++)
        //     fprintf(ff, "%f\t%i\t%.6f\n", c.test[t]->m[j].r, j, (double) c.test[t]->m[c.ni+c.nh+j].r);
        // fprintf(ff, "\n");
//      //   OrgHolisticTest(v);
      }
      if (gen % 5000 == 0)
      {
        if (c.errorweight)
          printf("Gen:%9ld\n", gen);
        else                                    // <<-- yuck, clean this up!
          printf("Generation: %9ld\n", gen);

        MatDisplay(v->ploid[0].M, "M"); //  threshold matrices.
        VecDisplay(v->ploid[0].B, "B", VDISPLAY);
      }
    }
  }
  MatDisplay(pop[0][0]->ploid[0].M, "M");
  VecDisplay(pop[0][0]->ploid[0].B, "B", VDISPLAY);
//                              ^ Temporary hack
  u = pop[0][0];
//  ^^^^^^^^^^^^^ Temporary hack

  OrgTest(u);

  printf("Test results:\n");
  for (t = 0; t < c.ntest; t++)
  {
    int i;

    printf("   Input:");
    for (i = 0; i < c.ni; i++)
      printf("  %+6.3f", (double) c.test[t]->m[i].r);

    printf("   Output:");
    for (i = 0; i < c.no; i++)
      printf("  %+8.3f", (double) c.test[t]->m[c.ni+c.nh+i].r);

    printf("\n");
  }
  printf("\n");
real xi = -1;
if (c.ntest > 1 && c.ni == 1 && c.no == 1) {
  int hyperness = 0;
  for (i=0; i<c.ntest; i++) {
    for (j=0; j<c.ntest-1; j++) {
      real testbase = c.test[i]->m[c.ni+c.nh].r;
      real testabove = c.test[j+1]->m[c.ni+c.nh].r;
      real testbelow = c.test[j]->m[c.ni+c.nh].r;
      if ((testabove >= testbase && testbase > testbelow) ||
          (testbelow >= testbase && testbase > testabove))
        hyperness += 1;
    }
  }
  // Each iteration through the loop of j's is guaranteed to hit at
  // least one neuron, so we divide by (c.ntest-1).
  xi = (real)hyperness/(c.ntest-1);
  printf("\n\nXi score is: %f\n\n", xi);
}
  OrgEval(u);
  if (c.outfile != NULL) {
    // If the file exists
    FILE *file = fopen(c.outfile, "r");
    int i;
    // File doesn't exist.  Open the file for writing and write the header
    if (file == NULL) {
      file = fopen(c.outfile, "a+");
      if (file == NULL) 
        printf("Could not open output file for writing.\n"), exit(1);
      // Write the csv header if the file doesn't exist
      fprintf(file, "RandSeed,Neurons,Ni,No,Ntrain,Ntest,Ploidy,Demes,PZero,"
                    "Population,Generations,Mutations,Iterations,Initzero,"
                    "Diffeq,Normall,Errorweight,Alpha,Beta,NoiseSigma,dist,"
                    "edist,wdist,Xi");
      for (i=0; i<c.ni; i++)
        for (j=0; j<c.ntest; j++)
          fprintf(file, ",Input_%i_Test_%i", i+1, j+1);
      for (i=0; i<c.no; i++)
        for (j=0; j<c.ntest; j++)
          fprintf(file, ",Output_%i_Test_%i", i+1, j+1);
      fprintf(file, "\n");
    }
    // File exists.  Open the file for writing.
    else {
      fclose(file);
      file = fopen(c.outfile, "a+");
      if (file == NULL)
        printf("Could not open output file for writing.\n"), exit(1);
    }
    
    //Write the test case data
    fprintf(file, "%i,%i,%i,%i,%i,%i,%i,%i,%.6f,%i,%i,%.6f,%i,%i,%i,%i,%i,%.6f,"
                  "%.6f,%.6f,%.6f,%.6f,%.6f,%.6f", 
            (int)c.seed,c.nn,c.ni,c.no,c.ntrain,c.ntest,c.ploidy,c.ndemes,c.pzero,
            (int)c.npop,(int)c.ngen,c.pmut,c.niter,c.initzero,c.diffeq,c.normall,
            c.errorweight,c.walpha,c.wbeta,c.sigma,u->dist,u->edist,u->wdist,xi);
    for (j=0; j<c.ni; j++)
      for (i=0; i<c.ntest; i++)
        fprintf(file, ",%.6f", (double) c.test[i]->m[j].r);
    for (j=0; j<c.no; j++)
      for (i=0; i<c.ntest; i++)
        fprintf(file, ",%.6f", (double) c.test[i]->m[c.ni+c.nh+j].r);
    fprintf(file, "\n");

    fclose(file);
  }
  if ((c.ni == 1) && (c.no == 1))
  {
    real x = 0.5;
//    real x = 0.152074;
    long i = 0;

    printf("SPECIAL ITERATION TEST:\n\n");

    for (i = 0; i < 1000+100; i++)
    {
//      if (kbhit())
      if (0)
      {
        int key = getch();
        if (key == KEY_NULL)
          getch();
        else if (key == KEY_ESC)
          break;
      }

      if (i >= 1000)
        printf("%6ld. %11.6f\n", i, x);

      x = OrgIter(u, x);
    }
  }
  for (i = 0; i < c.ndemes; i++)
  for (j = 0; j < c.npop;   j++)
    OrgDestroy(pop[i][j]);
  DestroyArray2(pop);
  return 0;
}
