/*----------------------------------------------------------------------------*
\Module{Function Prototypes}

This header file is temporary until I get the automatic protyping into place.


From 'config.d'
*/

bool  ReadConfiguration     (char *filename);
bool  ReadArgConfiguration  (int argc, char *argv[]);
void  DisplayConfiguration  (void);


/*----------------------------------------------------------------------------*
From 'organism.d'
*/

Org    *OrgCreate       (int ploidy);
Org    *OrgClone        (Org *o);
void    OrgDestroy      (Org *o);
Org    *OrgCopy         (Org *u, Org *v);
Org    *OrgInit         (Org *o);
Org    *OrgRand         (Org *o);
Org    *OrgZero         (Org *o);
Org    *OrgFromCoords   (Org *o, char icoords[]);
void    OrgMutate       (Org *o);
void    OrgHolisticTest (Org *o);
real    OrgEval         (Org *o);
real    OrgTrain        (Org *o, Vector *train);
void    OrgTest         (Org *o);
void    OrgExec         (Org *o, int p);
real    OrgIter         (Org *o, real x);
void    OrgNorm         (Org *o);
int     OrgInsert       (Org *pop[], int npop, Org *o);
real    Normalize       (real x);
real    Gaussian        (real sigma);


/*----------------------------------------------------------------------------*
From 'matrix.d'
*/

Matrix *MatCreate       (int di, int dj);
Vector *VecCreate       (int di);

void    MatDestroy      (Matrix *A);
void    VecDestroy      (Vector *A);

Matrix *MatCopy         (Matrix *A, Matrix *B);
Vector *VecCopy         (Vector *A, Vector *B);

void    MatStore        (Matrix *A, int i, int j, real r, bool mut);
void    VecStore        (Vector *A, int i, real r, bool mut);

void    MatMutate       (Matrix *A, real p, real pz, real r);
void    VecMutate       (Vector *A, real p, real pz, real r);

real    MatWeight       (Matrix *A, real alpha, real beta);
real    VecWeight       (Vector *A, real alpha, real beta);

real    MatLookup       (Matrix *A, int i, int j);
real    VecLookup       (Vector *A, int i);

void    VecAdd          (Vector *C, Vector *A, Vector *B);
void    MatVecMult      (Vector *C, Matrix *A, Vector *B);

void    MatDisplay      (Matrix *A, char *name);
void    VecDisplayRange (Vector *A, int i0, int di, char *name, int format);
void    VecDisplay      (Vector *A, char *name, int format);

/*----------------------------------------------------------------------------*
From 'array.d'
*/

void  *Alloc            (int n);
void   Release          (void *p);

void  *CreateArray1     (int di, size_t t);
void   DestroyArray1    (void *a);

void **CreateArray2     (int di, int dj, size_t t);
void   DestroyArray2    (void *a);


/*----------------------------------------------------------------------------*
From 'error.d'
*/

void AssertFunc (char *file, int line, char *expr);


/*----------------------------------------------------------------------------*
From 'rand.d'
*/

double          Rand          (void);
unsigned long   RandStart     (unsigned long k);
unsigned long   RandStartArb  (void);
unsigned long   RandInteger   (void);


